(PackageInfo named: 'ContextS2-Core') postscriptOfRemoval: '"below, add code to clean up after the unloading of this package"
[(Process respondsTo: #removeInstVarName:)
	ifTrue: [Process removeInstVarName: ''csInfo'']
	ifFalse: [Process removeInstVarNamed: ''csInfo'']] on: Warning do: [:e | e resume].
'!
(PackageInfo named: 'ContextS2-Core') preamble: '"below, add code to be run before the loading of this package"
[(Process respondsTo: #addInstVarName:)
	ifTrue: [Process addInstVarName: ''csInfo'']
	ifFalse: [Process addInstVarNamed: ''csInfo'']]
	 on: Warning do: [:e | e resume].
'!
SystemOrganization addCategory: #'ContextS2-Core-Tools'!
SystemOrganization addCategory: #'ContextS2-Core'!
(PackageInfo named: 'ContextS2-Core') postscript: '"below, add code to be run after the loading of this package"
CSMethodObject doneBootstrapping.'!

!CompiledMethod methodsFor: '*contexts2-core' stamp: 'tfel 3/28/2012 11:43:11.468'!
asPartialMethod
	| layer |
	layer := (self pragmas
		detect: [:ea | ea keyword == CSLayeredMethod pragmaKeyword]
		ifNone: [])
		ifNotNilDo: [:pragma || argument |
			pragma arguments size == 1
				ifFalse: [self error: 'Illegal ContextS2-Pragma: Need only one argument.'].
			argument := pragma arguments first.
			argument isArray ifTrue: [argument] ifFalse: [{argument}]].
	(layer isNil or: [layer allSatisfy: #isSymbol])
		ifFalse: [self error: 'Illegal ContextS2-Pragma: Need Symbol or Array of Symbols as parameter.'].
	^ CSPartialMethod on: layer forMethod: self! !

!CompiledMethod methodsFor: '*contexts2-core' stamp: 'tfel 2/23/2012 17:46:49.222'!
asSymbol

	^ self selector! !

!Array methodsFor: '*contexts2-core' stamp: 'tfel 3/21/2012 16:06:00.197'!
activateLayersInCurrentProcess
	
	| layerNames activeLayers |
	layerNames := self collect: #layerName.
	activeLayers := Processor activeProcess csInfo activeLayers.
	^ Processor activeProcess csInfo activeLayers: (activeLayers, layerNames) asSet asArray! !

!Array methodsFor: '*contexts2-core' stamp: 'tfel 3/21/2012 16:08:23.147'!
deactivateLayersInCurrentProcess
	
	| layerNames activeLayers |
	layerNames := self collect: #layerName.
	activeLayers := Processor activeProcess csInfo activeLayers.
	^ Processor activeProcess csInfo activeLayers: (activeLayers copyWithoutAll: self)! !

!Array methodsFor: '*contexts2-core' stamp: 'ag 1/27/2012 16:48:52.707'!
withLayersDo: aBlock
	"Memorize currently active layers, add the new ones and restore the state afterwards.
	The layer-name-symbols are extracted from the receiver, in case real CSLayer-object are stored here.
	TODO in future, change internal layer-management to only use real layer-objects."
	
	| layerNames |
	layerNames := self collect: #layerName.
	^ Processor activeProcess csInfo
		withLayers: (Processor activeProcess csInfo activeLayers copyWithoutAll: layerNames), layerNames
		do: aBlock! !

!Array methodsFor: '*contexts2-core' stamp: 'ag 12/20/2011 21:31'!
withoutLayersDo: aBlock
	"Memorize currently active layers, remove some and restore the state afterwards."
	
	^ Processor activeProcess csInfo
		withLayers: (Processor activeProcess csInfo activeLayers copyWithoutAll: self)
		do: aBlock! !

MethodReference subclass: #CSMethodReference
	instanceVariableNames: 'method'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2-Core-Tools'!

!CSMethodReference class methodsFor: 'instance creation' stamp: 'tfel 2/23/2012 18:54:11.379'!
onMethod: aMethod

	^ (self class: aMethod methodClass selector: aMethod selector)
		method: aMethod;
		yourself! !

!CSMethodReference methodsFor: 'monticello' stamp: 'tfel 2/23/2012 19:06:54.797'!
asMethodDefinition
	"Override, unification happens based on class and selector in MC"
	^ (MCMethodDefinition forMethodReference: self)
		selector: self method asSymbol;
		yourself! !

!CSMethodReference methodsFor: 'accessing' stamp: 'tfel 3/28/2012 13:56:35.781'!
category
	"Answers the class category (cached for reuse via MC and other tools)"
	| actualClass |
	actualClass := Smalltalk globals at: classSymbol ifPresent: [ :class |
		classIsMeta
			ifTrue: [ class classSide ]
			ifFalse: [ class ] ].
	^ category ifNil: [category := actualClass organization categoryOfElement: self method asSymbol]! !

!CSMethodReference methodsFor: 'monticello' stamp: 'tfel 2/23/2012 18:42:27.33'!
compiledMethod

	^ self method! !

!CSMethodReference methodsFor: 'accessing' stamp: 'tfel 2/23/2012 18:40:15.256'!
method
	"Answer the value of method"

	^ method! !

!CSMethodReference methodsFor: 'accessing' stamp: 'tfel 2/23/2012 18:40:15.277'!
method: anObject
	"Set the value of method"

	method := anObject! !

!CSMethodReference methodsFor: 'accessing' stamp: 'tfel 3/5/2012 16:12:34.389'!
methodSymbol

	^ self method selector! !

!CSMethodReference methodsFor: 'printing' stamp: 'tfel 3/28/2012 13:56:57.964'!
printOn: aStream
	"Print the receiver on a stream"
	| actualClass |
	actualClass := Smalltalk globals at: classSymbol ifPresent: [ :class |
		classIsMeta
			ifTrue: [ class classSide ]
			ifFalse: [ class ] ].
	aStream
		nextPutAll: 'a ';
		nextPutAll: self class name;
		nextPutAll: ' ', actualClass name, ' >> ', self methodSymbol.! !

!CSMethodReference methodsFor: 'monticello' stamp: 'tfel 2/23/2012 18:55:02.754'!
source

	^ self method getSource asString! !

!CSMethodReference methodsFor: 'packageinfo-base' stamp: 'tfel 2/23/2012 18:55:09.204'!
sourceCode

	^ self source asString! !

!MessageSet methodsFor: '*contexts2-core-override-private' stamp: 'tfel 3/21/2012 13:15:10.074'!
initializeMessageList: anArray
	"Initialize my messageList from the given list of MethodReference or string objects.  NB: special handling for uniclasses."
	"overridden to avoid re-creating method references."
	
	messageList := OrderedCollection new.
	anArray do: [ :each |
		"--- BEGIN OVERRIDE CHANGE ---"
		(each isKindOf: MethodReference)
			ifTrue: [messageList add: each]
			ifFalse: [
		"--- END OVERRIDE CHANGE ---"
				MessageSet 
					parse: each  
					toClassAndSelector: [ :class :sel | | s |
						class ifNotNil:
							[class isUniClass
								ifTrue:
									[s := class typicalInstanceName, ' ', sel]
								ifFalse:
									[s := class name , ' ' , sel , ' {' , 
										((class organization categoryOfElement: sel) ifNil: ['']) , '}'].
							messageList add: (
								MethodReference new
									setClass: class  
									methodSymbol: sel 
									stringVersion: s)]]]].
	messageListIndex := messageList isEmpty ifTrue: [0] ifFalse: [1].
	contents := ''! !

!MessageSet methodsFor: '*contexts2-core-override-message list' stamp: 'tfel 3/21/2012 13:32:27.15'!
selectedMessage
	"Answer the source method for the currently selected message."
	"overridden to use method references"
	(self selection isKindOf: MethodReference)
		ifTrue: [| source |
			[currentCompiledMethod := self selection compiledMethod.
			source := self selection source.
			^ source asText makeSelectorBoldIn: self selection actualClass] on: Error do: []].
		
	"--- BEGIN SQUEAK CORE CODE ---"
	self setClassAndSelectorIn: [:class :selector | | source | 
		class ifNil: [^ 'Class vanished'].
		selector first isUppercase ifTrue:
			[selector == #Comment ifTrue:
				[currentCompiledMethod := class organization commentRemoteStr.
				^ class comment].
			selector == #Definition ifTrue:
				[^ class definition].
			selector == #Hierarchy ifTrue: [^ class printHierarchy]].
		source := class sourceMethodAt: selector ifAbsent:
			[currentCompiledMethod := nil.
			^ 'Missing'].

		self showingDecompile ifTrue: [^ self decompiledSourceIntoContents].

		currentCompiledMethod := class compiledMethodAt: selector ifAbsent: [nil].
		self showingDocumentation ifTrue: [^ self commentContents].

	source := self sourceStringPrettifiedAndDiffed.
	^ source asText makeSelectorBoldIn: class]! !

!ClassDescription methodsFor: '*contexts2-core-override-accessing method dictionary' stamp: 'tfel 3/6/2012 11:11:39.803'!
addAndClassifySelector: selector withMethod: compiledMethod inProtocol: category notifying: requestor
	| priorMethodOrNil |
	(compiledMethod isCompiledMethod or: [
		(compiledMethod respondsTo: #isBase) and: [compiledMethod isBase]]) ifTrue: [

	"--- START OF COPIED CODE FROM SQUEAK KERNEL ---"
	priorMethodOrNil := self compiledMethodAt: selector ifAbsent: [nil].
	self addSelectorSilently: selector withMethod: compiledMethod.
	SystemChangeNotifier uniqueInstance 
		doSilently: [self organization classify: selector under: category].
	priorMethodOrNil isNil
		ifTrue: [SystemChangeNotifier uniqueInstance methodAdded: compiledMethod selector: selector inProtocol: category class: self requestor: requestor]
		ifFalse: [SystemChangeNotifier uniqueInstance methodChangedFrom: priorMethodOrNil to: compiledMethod selector: selector inClass: self requestor: requestor].
	"--- END OF COPIED CODE FROM SQUEAK KERNEL ---"

	] ifFalse: ["dealing with a partial layer method"
		priorMethodOrNil := self layeredMethodDict at: compiledMethod asSymbol ifAbsent: [nil].
		self addSelectorSilently: selector withMethod: compiledMethod.
		SystemChangeNotifier uniqueInstance
			doSilently: [self organization classify: compiledMethod asSymbol under: category].
		priorMethodOrNil
			ifNil: [SystemChangeNotifier uniqueInstance
						methodAdded: compiledMethod selector: compiledMethod asSymbol
						inProtocol: category class: self requestor: requestor]
			ifNotNil: [SystemChangeNotifier uniqueInstance
						methodChangedFrom: priorMethodOrNil to: compiledMethod
						selector: compiledMethod asSymbol inClass: self requestor: requestor].
	].
! !

!SystemNavigation methodsFor: '*contexts2-core-override-query' stamp: 'tfel 3/21/2012 13:05:12.468'!
allCallsOn: aLiteral fromBehaviors: behaviors sorted: sorted
	"Answer a collection of all the methods implemented by behaviors that call on aLiteral even deeply embedded in literal array."
	"--- BEGIN SQUEAK CORE CODE ---"	
	| result special thorough byte |
	result := OrderedCollection new.
	special := Smalltalk hasSpecialSelector: aLiteral ifTrueSetByte: [ :b | byte := b ].
	"Possibly search for symbols imbedded in literal arrays"
	thorough := aLiteral isSymbol and: [ Preferences thoroughSenders ].
	behaviors do: [ :behavior |
		| list | 
		list := behavior whichSelectorsReferTo: aLiteral special: special byte: byte thorough: thorough.
		list do: [ :selector |
			result add: (MethodReference class: behavior selector: selector) ] ].
	sorted ifTrue: [ result sort ].
	"--- END SQUEAK CORE CODE ---"
	(behaviors respondsTo: #reset) ifTrue: [behaviors reset].  
	behaviors do: [:behavior || list |
		list := behavior layeredMethods gather: [:method |
			method partialMethods select: [:partial | partial hasLiteral: aLiteral]].
		list do: [:partial | result add: (CSMethodReference onMethod: partial)]].
	sorted ifTrue: [ result sort ].
	^ result! !

!Parser class methodsFor: '*contexts2-core-override-accessing' stamp: 'ag 12/20/2011 21:39'!
primitivePragmaSelectors
	"Answer the selectors of pragmas that specify VM primitives.
	 Needed for compile and decomple."
	^#(primitive:
		primitive:error:
		primitive:error:module:
		primitive:module:
		primitive:module:error:
		), CSLayeredMethod pragmaKeyword! !

!Parser methodsFor: '*contexts2-core' stamp: 'ag 12/20/2011 21:40'!
layer: aCollectionOfLayers
	^ 0! !

Browser subclass: #CSBrowser
	instanceVariableNames: 'selectedLayerSymbol'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2-Core-Tools'!

!CSBrowser class methodsFor: 'constants' stamp: 'tfel 2/23/2012 16:30:14.747'!
allLayersMarker
	
	^ #'-- all --'! !

!CSBrowser class methodsFor: 'constants' stamp: 'tfel 2/23/2012 16:30:09.869'!
baseMethodsMarker
	
	^ #'-- base methods --'! !

!CSBrowser class methodsFor: 'class initialization' stamp: 'tfel 3/28/2012 12:11'!
initialize
	| menu |
	super initialize.
	menu := (Smalltalk at: #TheWorldMenu ifAbsent: [^ self]).
	(menu respondsTo: #registerOpenCommand:) ifTrue: [
		menu registerOpenCommand: {'ContextS Browser'. {self. #open}}].! !

!CSBrowser class methodsFor: 'constants' stamp: 'tfel 2/23/2012 16:30:04.976'!
nonLayeredMarker
	
	^ #'-- non-layered --'! !

!CSBrowser methodsFor: 'message list' stamp: 'tfel 3/5/2012 14:24:19.09'!
allLayersAndMethodsFrom: aList

	^ aList! !

!CSBrowser methodsFor: 'message list' stamp: 'tfel 3/5/2012 14:25:19.179'!
baseMethodsFrom: aList

	^ (aList select: [:method | method isContextSMethod])
		select: [:method | method isBase]! !

!CSBrowser methodsFor: 'Tools' stamp: 'tfel 2/28/2012 16:06:36.843'!
browseVersions

	^ [super browseVersions]
		on: Error
		do: [:e | self inform: 'Sorry. Only actual methods can show versions'].! !

!CSBrowser methodsFor: 'toolbuilder' stamp: 'tfel 2/23/2012 16:02:42.692'!
buildContextLayerListWith: builder
	
	^ builder pluggableListSpec new
		model: self;
		list: #contextLayerList;
		getIndex: #selectedLayerIndex;
		setIndex: #selectedLayerIndex:;
		menu: #contextLayerMenu:;
		keyPress: #arrowKey:from:;
		yourself! !

!CSBrowser methodsFor: 'toolbuilder' stamp: 'tfel 2/23/2012 17:56:37.637'!
buildWindowWith: builder specs: aSpecList
	| paneSpecs codeSpec slimPaneSpecs layerPaneSpec layerPaneFrame |
	paneSpecs := aSpecList first: 5.
	codeSpec := aSpecList last.
	slimPaneSpecs := self compressWidthOfSpecs: paneSpecs from: 1/4 to: 1/5.
	layerPaneFrame := slimPaneSpecs first key copy
							leftFraction: 0.8;
							rightFraction: 1;
							yourself.
	layerPaneSpec := layerPaneFrame -> [self buildContextLayerListWith: builder].
	self when: #classSelectionChanged send: #resetLayers to: self.
	^ super
		buildWindowWith: builder
		specs: slimPaneSpecs, {layerPaneSpec}, {codeSpec}! !

!CSBrowser methodsFor: 'toolbuilder' stamp: 'tfel 2/23/2012 16:46:17.613'!
compressWidthOfSpecs: specs from: aFraction to: anotherFraction

	^ specs collect: [:assoc || frame |
		frame := assoc key isRectangle
					ifTrue: [LayoutFrame fractions: assoc key] ifFalse: [assoc key].
		frame rightFraction: frame rightFraction / aFraction * anotherFraction.
		frame leftFraction: frame leftFraction / aFraction * anotherFraction.
		frame -> assoc value].
! !

!CSBrowser methodsFor: 'layer list' stamp: 'tfel 2/23/2012 16:04:58.234'!
contextLayerList
	
	^ self selectedClassOrMetaClass
		ifNil: [#()]
		ifNotNilDo: [:class |
			{ self class allLayersMarker.
			self class nonLayeredMarker.
			self class baseMethodsMarker },
			self selectedClassOrMetaClass allInvolvedLayers asArray ]! !

!CSBrowser methodsFor: 'layer list' stamp: 'tfel 2/23/2012 18:01:34.413'!
contextLayerMenu: aMenu
	
	(self menuHook: aMenu named: #messageCategoryMenu shifted: false).
	^ aMenu
		labels: 'delete layer'
		lines: #()
		selections: #(deleteSelectedLayer)! !

!CSBrowser methodsFor: 'initialize-release' stamp: 'tfel 2/23/2012 16:16:16.924'!
defaultBrowserTitle
	
	^ 'Context Browser'! !

!CSBrowser methodsFor: 'layer functions' stamp: 'tfel 2/23/2012 18:05:09.168'!
deleteSelectedLayer

	self inform: 'Not implemented'.! !

!CSBrowser methodsFor: 'drag and drop' stamp: 'tfel 3/5/2012 14:00:14.424'!
dragFromMessageList: index

	^ self messageObjectsList at: index! !

!CSBrowser methodsFor: 'drag and drop' stamp: 'tfel 3/5/2012 14:28:23.368'!
dropOnMessageCategories: method at: index

	method isContextSMethod ifTrue: [| targetClass |
		targetClass := self selectedClassOrMetaClass.
		(targetClass == method methodClass)
			ifTrue: [| category |
				category := self messageCategoryList at: index.
				category = ClassOrganizer allCategory ifTrue: [^ false].
				targetClass organization classify: method asSymbol under: category.
				^ true]
			ifFalse: [^ self inform: 'Can only move partial methods within a class']].
	^ super dropOnMessageCategories: method at: index! !

!CSBrowser methodsFor: 'user interface' stamp: 'tfel 2/28/2012 10:31:38.455'!
initialExtent
	| baseExtent |
	baseExtent := super initialExtent.
	^ (baseExtent x / 4 * 5)@(baseExtent y)! !

!CSBrowser methodsFor: 'message list' stamp: 'tfel 2/23/2012 17:46:28.392'!
messageList
	
	^ self messageObjectsList collect: #asSymbol! !

!CSBrowser methodsFor: 'message list' stamp: 'tfel 3/5/2012 14:56:51.303'!
messageObjectsList
	| list |
	self selectedClassOrMetaClass ifNil: [^ #()].
	list := self methodObjectsIn: super messageList from: self selectedClassOrMetaClass.
	^ self selectedLayerSymbol
		caseOf: {[self class nonLayeredMarker] -> [self nonLayeredMessagesFrom: list].
	 				[self class allLayersMarker] -> [self allLayersAndMethodsFrom: list].
	 				[self class baseMethodsMarker] -> [self baseMethodsFrom: list]}
		otherwise: [self messagesInLayer: self selectedLayerSymbol from: list]! !

!CSBrowser methodsFor: 'message list' stamp: 'tfel 3/5/2012 14:25:58.771'!
messagesInLayer: aSymbol from: aList

	^ (aList select: [:method | method isContextSMethod])
		select: [:method | method layers includes: self selectedLayerSymbol]! !

!CSBrowser methodsFor: 'message list' stamp: 'tfel 3/5/2012 15:11:33.076'!
methodObjectsIn: aList from: aClass
	"aList may include symbols that point to CompiledMethods, CSLayeredMethods or CSPartialMethods within CSLayeredMethods of the method dictionary in aClass"
	| partials |
	partials := aClass layeredMethods gather: [:m | m partialMethods].
	^ (aList collect: [:selector | aClass compiledMethodAt: selector ifAbsent: [selector]])
		collect: [:method |
			method class caseOf: {
			[CompiledMethod] -> [method].
			[CSLayeredMethod] -> [method basePartialMethod].
			[ByteSymbol] -> [partials detect: [:m | m asSymbol = method] ifNone: []]}]
			thenSelect: [:m | m notNil]! !

!CSBrowser methodsFor: 'message list' stamp: 'tfel 2/23/2012 17:45:25.34'!
nonLayeredMessagesFrom: aList

	^ aList select: [:method | method isContextSMethod not]! !

!CSBrowser methodsFor: 'message functions' stamp: 'tfel 2/23/2012 18:11:46.858'!
removeMessage
	"Changed to delete only one partial method for ContextS methods."
	| method confirmation |
	self messageListIndex = 0 | self okToChange not ifTrue: [^ self].
	method := self messageObjectsList at: self messageListIndex.
	method isContextSMethod ifFalse: [^ super removeMessage].

	confirmation := self systemNavigation 
							confirmRemovalOf: method selector
							on: self selectedClassOrMetaClass.
	confirmation = 3 ifTrue: [^ self].
	
	(self selectedClassOrMetaClass >> method selector) removePartialMethod: method.
	self changed: #messageList.
	self messageListIndex: 0.
	
	self setClassOrganizer.
	"In case organization not cached"
	confirmation = 2 ifTrue: [self systemNavigation browseAllCallsOn: method selector].! !

!CSBrowser methodsFor: 'layer list' stamp: 'tfel 2/23/2012 17:57:30.108'!
resetLayers
	
	self selectedLayerIndex: 0.  ! !

!CSBrowser methodsFor: 'layer list' stamp: 'tfel 2/23/2012 16:07:53.324'!
selectedLayerIndex
	
	^ self contextLayerList indexOf: self selectedLayerSymbol! !

!CSBrowser methodsFor: 'layer list' stamp: 'tfel 2/23/2012 16:50:10.884'!
selectedLayerIndex: anInteger
	
	self selectedLayerSymbol: (self contextLayerList at: anInteger ifAbsent: []).
	self
		changed: #selectedLayerIndex;
		changed: #contextLayerList;
		changed: #messageCategoryList;
		changed: #relabel;
		contentsChanged;
		messageCategoryListIndex: 1. "Select the --all-- category, deselect messages."! !

!CSBrowser methodsFor: 'accessing' stamp: 'tfel 2/23/2012 16:06:26.772'!
selectedLayerSymbol
	"This returns the name of the layer (as symbol), not the layer object."
	
	^ selectedLayerSymbol ifNil: [selectedLayerSymbol := self class allLayersMarker]! !

!CSBrowser methodsFor: 'accessing' stamp: 'tfel 2/23/2012 16:07:40.398'!
selectedLayerSymbol: anObject
	"Set the value of selectedLayerSymbol"

	selectedLayerSymbol := anObject! !

!CSBrowser methodsFor: 'message list' stamp: 'tfel 3/5/2012 17:17:32.331'!
selectedMessage

	^ (super selectedMessage isEmpty and: [self messageListIndex = 0])
		ifTrue: ['']
		ifFalse: [(self messageObjectsList at: self messageListIndex ifAbsent: [^ '']) getSource]
! !

!CSBrowser methodsFor: 'drag and drop' stamp: 'tfel 3/5/2012 14:52:25.94'!
wantsMessageCategoriesDrop: anObject

	^ (super wantsMessageCategoriesDrop: anObject) or: [anObject isContextSMethod]! !

Browser subclass: #CSContextBrowser
	instanceVariableNames: 'selectedLayerIndex contextLayerList messageCategoryList messageList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2-Core-Tools'!

!CSContextBrowser class methodsFor: 'constants' stamp: 'ag 1/22/2012 15:22:53.043'!
allLayersMarker
	
	^ #'-- all --'! !

!CSContextBrowser class methodsFor: 'constants' stamp: 'ag 1/20/2012 22:16:40.498'!
baseMethodsMarker
	
	^ #'-- base methods --'! !

!CSContextBrowser class methodsFor: 'constants' stamp: 'ag 1/22/2012 10:34:34.381'!
nonLayeredMarker
	
	^ #'-- non-layered --'! !

!CSContextBrowser methodsFor: 'ui-layers' stamp: 'ag 1/22/2012 18:20:57.702'!
buildContextLayerListWith: builder
	
	^ builder pluggableListSpec new
		model: self;
		list: #contextLayerList;
		getIndex: #selectedLayerIndex;
		setIndex: #selectedLayerIndex:;
		menu: #contextLayerMenu:;
		keyPress: #arrowKey:from:;
		yourself! !

!CSContextBrowser methodsFor: 'ui' stamp: 'tfel 2/23/2012 14:43:05.903'!
buildMessageCategoryBrowserEditString: aString
	"Copied from superclass, changed to integrate with other functionality of this class (Correctly select the index of the selected message category)."

	"Create and schedule a message category browser for the currently 
	selected	 message category. The initial text view contains the characters 
	in aString."
	"wod 6/24/1998: set newBrowser classListIndex so that it works whether the
	receiver is a standard or a Hierarchy Browser."

	| newBrowser |
	self messageCategoryListIndex ~= 0
		ifTrue: 
			[newBrowser := Browser new.
			newBrowser metaClassIndicated: metaClassIndicated.			
			newBrowser systemCategoryListIndex: (newBrowser systemCategoryList indexOf: self selectedSystemCategoryName).
			newBrowser classListIndex: (newBrowser classList indexOf: self selectedClassName).
			newBrowser messageCategoryListIndex: (newBrowser messageCategoryList indexOf: self selectedMessageCategoryName).
			self selectedMessageName ifNotNil: [
				newBrowser messageListIndex: (newBrowser messageList indexOf: self selectedMessageName) ].

			self class openBrowserView: (newBrowser openMessageCatEditString: aString)
				label: 'Message Category Browser (' , 
						newBrowser selectedClassOrMetaClassName , ')']! !

!CSContextBrowser methodsFor: 'initialize-release' stamp: 'ag 1/31/2012 23:00:51.057'!
changed: aSymbol
	"TODO maybe this is not the right way to get the changed-event of the reicever itself..."
	
	aSymbol caseOf: {
		[ #messageList ] -> [ messageList := nil ].
		[ #messageCategoryList ] -> [ messageCategoryList := nil ].
		[ #contextLayerList ] -> [ contextLayerList := nil ].
	} otherwise: [].
	super changed: aSymbol.! !

!CSContextBrowser methodsFor: 'ui' stamp: 'tfel 2/23/2012 14:43:29.32'!
classListIndex: aNumber
	
	selectedLayerIndex := 0. "Set the variable first, do all the real updates after the super-call."
	self messageCategoryListIndex: 0.
	super classListIndex: aNumber.
	self selectedLayerIndex: 0.! !

!CSContextBrowser methodsFor: 'ui-messages' stamp: 'ag 1/31/2012 15:29:58.83'!
completeMessageList
	
	| messages |
	messages := SortedCollection sortBlock: [ :mt1 :mt2 |
		(mt1 isSymbol ifTrue: [ mt1 ] ifFalse: [ mt1 selector ]) <= (mt2 isSymbol ifTrue: [ mt2 ] ifFalse: [ mt2 selector ]) ].
	(self selectedClassOrMetaClass ifNil: [ ^ #() ]) methodDict
		valuesDo: [ :method |
			method selector ifNotEmpty: [
				(method isKindOf: CSLayeredMethod)
					ifTrue: [ messages addAll: method allPartialMethods ]
					ifFalse: [ messages add: method selector ] ] ].
	^ messages! !

!CSContextBrowser methodsFor: 'ui-layers' stamp: 'tfel 2/23/2012 14:41:46.439'!
contextLayerList
	
	^ contextLayerList ifNil: [
		contextLayerList := self classListIndex = 0
			ifTrue: [ Array new ] "No class selected"
			ifFalse: [ 
				{ self class allLayersMarker. self class nonLayeredMarker. self class baseMethodsMarker },
				self selectedClassOrMetaClass allInvolvedLayers asArray ] ]! !

!CSContextBrowser methodsFor: 'ui-layers' stamp: 'ag 1/22/2012 18:25:48.119'!
contextLayerMenu: aMenu
	
	(self menuHook: aMenu named: #messageCategoryMenu shifted: false) ifTrue: [ ^ aMenu ].
	^ aMenu
		labels: 'delete layer'
		lines: #()
		selections: #(deleteSelectedLayer)! !

!CSContextBrowser methodsFor: 'initialize-release' stamp: 'ag 1/12/2012 12:06'!
defaultBrowserTitle
	
	^ 'Context Browser'! !

!CSContextBrowser methodsFor: 'ui-actions' stamp: 'ag 1/20/2012 21:42:35.885'!
deleteSelectedLayer
	"When the layer is deleted, we delete all partial methods on it.
	If the partial method was the last one in its LayeredMethod, we delete the LayeredMethod <??>"
	
	self selectedLayer delete.
	self selectedLayerIndex: 0.! !

!CSContextBrowser methodsFor: 'initialize-release' stamp: 'ag 1/31/2012 15:32:27.19'!
initialize
	
	super initialize.
	selectedLayerIndex := 0.! !

!CSContextBrowser methodsFor: 'ui' stamp: 'ag 1/31/2012 23:05:22.837'!
messageCategoryList
	
	^ messageCategoryList ifNil: [
		messageCategoryList := SortedCollection with: ClassOrganizer allCategory.
		(self selectedClassOrMetaClass ifNil: [ ^ #() ]) methodDict keysAndValuesDo: [ :key :value |
			(self selectedLayer = self class allLayersMarker
			or: [
			(self selectedLayer = self class nonLayeredMarker)
				ifTrue: [ value class ~= CSLayeredMethod ]
				ifFalse: [
					value class == CSLayeredMethod and: [
						(self selectedLayer = self class baseMethodsMarker
							ifTrue: [ value hasBaseMethod ]
							ifFalse: [ value allInvolvedLayers includes: self selectedLayer ]) ] ] ]
			) ifTrue: [
				(self classOrMetaClassOrganizer categoryOfElement: key)
					ifNotNilDo: [ :category | messageCategoryList addIfNotPresent: category ] ] ].
		messageCategoryList ]! !

!CSContextBrowser methodsFor: 'ui-messages' stamp: 'ag 1/31/2012 22:54:34.758'!
messageList
	"Select those (partial) methods, that match both the selected category and selected layer."
	
	^ messageList ifNil: [
		messageList := self completeMessageList select: [ :method |
			"First filter the category"
			(self selectedMessageCategoryName isNil
				or: [ self selectedMessageCategoryName = ClassOrganizer allCategory ]
				or: [ (self classOrMetaClassOrganizer categoryOfElement: method asSymbol) = self selectedMessageCategoryName ])
			and: [
			
			"Then the layer"
			self selectedLayer = self class allLayersMarker
			or: [
			(self selectedLayer = self class nonLayeredMarker)
				ifTrue: [ (method isKindOf: CSMethodObject) not ]
				ifFalse: [
					(method isKindOf: CSMethodObject) and: [
						(self selectedLayer = self class baseMethodsMarker)
							ifTrue: [ method isBase ]
							ifFalse: [ method layers includes: self selectedLayer ] ] ] ] ] ] ]! !

!CSContextBrowser methodsFor: 'initialize-release' stamp: 'ag 1/31/2012 15:33:37.095'!
metaClassIndicated: aBool
	"This value is set when one of the instance/class buttons is clicked."
	
	selectedLayerIndex := 0.
	super metaClassIndicated: aBool.
	self changed: #contextLayerList.! !

!CSContextBrowser methodsFor: 'initialize-release' stamp: 'ag 1/22/2012 18:09:56.262'!
openEditString: aString
	"Create a pluggable version of all the views for a Browser, including views and controllers."
	"CSContextBrowser fullOnClass: Browser"
	
	| builder max |
	builder := ToolBuilder default.
	max := self wantsOptionalButtons ifTrue: [ 0.42 ] ifFalse: [ 0.5 ].
	^ self buildWindowWith: builder specs: {
		(0@0 corner: 0.2@max) -> [self buildSystemCategoryListWith: builder].
		(0.2@0 corner: 0.4@(max-0.08)) -> [self buildClassListWith: builder].
		(0.2@(max-0.08) corner: 0.4@max) -> [self buildSwitchesWith: builder].
		(0.6@0 corner: 0.8@max) -> [ self buildMessageCategoryListWith: builder ].
		(0.4@0 corner: 0.6@max) -> [self buildContextLayerListWith: builder].
		(0.8@0 corner: 1@max) -> [self buildMessageListWith: builder].
		(0@max corner: 1@1) -> [self buildCodePaneWith: builder]
	}! !

!CSContextBrowser methodsFor: 'ui-messages' stamp: 'tfel 2/23/2012 14:44:06.225'!
removeMessage
	"Copied from super-class, changed to delete only one partial method."
	
	| method confirmation |
	self messageListIndex = 0 | self okToChange not ifTrue: [^ self].
	method := self selectedMethod.
	method isSymbol ifTrue: [ ^ super removeMessage ].
	confirmation := self systemNavigation confirmRemovalOf: method selector on: self selectedClassOrMetaClass.
	confirmation = 3 ifTrue: [^ self].
	
	(self selectedClassOrMetaClass >> method selector) removePartialMethod: method.
	self changed: #messageList.
	self messageListIndex: 0.
	
	self setClassOrganizer.
	"In case organization not cached"
	confirmation = 2 ifTrue: [self systemNavigation browseAllCallsOn: method selector]! !

!CSContextBrowser methodsFor: 'ui-layers' stamp: 'ag 1/22/2012 14:46:04.694'!
selectedLayer
	"This returns the name of the layer (as symbol), not the layer object."
	
	^ self selectedLayerIndex = 0
		ifTrue: [ self class allLayersMarker ]
		ifFalse: [ self contextLayerList at: self selectedLayerIndex ]! !

!CSContextBrowser methodsFor: 'ui-layers' stamp: 'ag 1/12/2012 12:45'!
selectedLayerIndex
	^ selectedLayerIndex! !

!CSContextBrowser methodsFor: 'ui-layers' stamp: 'tfel 2/23/2012 14:43:49.154'!
selectedLayerIndex: anObject
	
	selectedLayerIndex := anObject.
	self messageCategoryListIndex: 1. "First just reset the variable, later do the real updates."
	self messageListIndex: 0.
	self
		changed: #selectedLayerIndex;
		changed: #contextLayerList;
		changed: #messageCategoryList;
		changed: #relabel;
		contentsChanged;
		messageCategoryListIndex: 1. "Select the --all-- category, deselect messages."! !

!CSContextBrowser methodsFor: 'ui-messages' stamp: 'ag 1/22/2012 23:08:24.183'!
selectedMessage
	"If the selected message is a normal CompiledMethods (the object then is the selector-symbol), use the super-version.
	Else, get the source from the special selected partial method."
	
	| messageName |
	messageName := self selectedMethod.
	messageName ifNil: [ ^ '' ].
	messageName isSymbol ifTrue: [ ^ super selectedMessage ].
	^ messageName getSource "is a CSPartialMethod"! !

!CSContextBrowser methodsFor: 'ui' stamp: 'tfel 2/23/2012 14:41:58.076'!
selectedMessageCategoryName
	"Be tolerant, when messageCategoryListIndex is too big."
	
	self messageCategoryListIndex = 0 ifTrue: [ ^ nil ].
	^ self messageCategoryListIndex <= self messageCategoryList size
		ifTrue: [ self messageCategoryList at: self messageCategoryListIndex ]! !

!CSContextBrowser methodsFor: 'ui' stamp: 'ag 1/22/2012 23:06:18.598'!
selectedMessageName
	"The result of the super-call might be a CSPartialMethod, "
	
	^ super selectedMessageName ifNotNilDo: #asSymbol! !

!CSContextBrowser methodsFor: 'ui' stamp: 'ag 1/22/2012 23:00:29.567'!
selectedMethod
	"Access either the symbol or the CSPartialMethod currently selected."
	
	^ super selectedMessageName! !

!Symbol methodsFor: '*contexts2-core' stamp: 'tfel 3/21/2012 16:01:51.691'!
activateLayerInCurrentProcess
	
	^ (Array with: self) activateLayersInCurrentProcess! !

!Symbol methodsFor: '*contexts2-core' stamp: 'ag 1/22/2012 14:51:21.558'!
asLayer
	"Return the first-class layer-object with the name represented by the receiver."
	
	^ CSLayer layerNamed: self! !

!Symbol methodsFor: '*contexts2-core' stamp: 'tfel 3/21/2012 16:02:29.832'!
deactivateLayerInCurrentProcess
	
	^ (Array with: self) deactivateLayersInCurrentProcess! !

!Symbol methodsFor: '*contexts2-core' stamp: 'ag 1/22/2012 14:52:50.783'!
layerName
	"Also implemented on CSLayer, to transparently access the layer-name of a layer-object without knowing whether it actually is the object or the name-symbol already."
	
	^ self! !

!Symbol methodsFor: '*contexts2-core' stamp: 'ag 12/22/2011 15:26'!
withLayerDo: aBlock
	
	^ (Array with: self) withLayersDo: aBlock! !

!Symbol methodsFor: '*contexts2-core' stamp: 'ag 12/22/2011 15:26'!
withoutLayerDo: aBlock
	
	^ (Array with: self) withoutLayersDo: aBlock! !

!PackageInfo methodsFor: '*contexts2-core' stamp: 'tfel 3/5/2012 16:13:35.416'!
layeredMethods
	| coreMethods extensionMethods |
	coreMethods := self classesAndMetaClasses gather: [:class | class layeredMethods].
	extensionMethods := (self externalBehaviors gather: [:classOrTrait |
		(self extensionCategoriesForClass: classOrTrait)
			gather: [:cat | (classOrTrait organization listAtCategoryNamed: cat)
				collect: [:selector || method |
					method := classOrTrait layeredMethodDict at: selector.
					method isContextSMethod ifTrue: [method]]]])
		reject: #isNil.
	^ (coreMethods, extensionMethods) gather: [:method |
		(method isKindOf: CSPartialMethod)
			ifTrue: [{CSMethodReference onMethod: method}]
			ifFalse: [method partialMethods collect: [:m |
						CSMethodReference onMethod: m]]]! !

!PackageInfo methodsFor: '*contexts2-core-override-listing' stamp: 'tfel 3/6/2012 11:22:50.149'!
methods
	^ ((
	"-- START COPIED CODE --"
	(self extensionMethods, self coreMethods) select: [:method |
		method isValid
			and: [method isLocalSelector
			and: [method methodSymbol isDoIt not]]]
	"-- END COPIED CODE --"
	) select: [:method || compiledMethod |
		compiledMethod := method compiledMethod.
		compiledMethod isCompiledMethod or: [
		compiledMethod  isContextSMethod and: [compiledMethod hasBaseMethod]]]),
	self layeredMethods! !

!Process methodsFor: '*contexts2-core' stamp: 'tfel 3/28/2012 11:24:35.874'!
csInfo
	"Only the contents of csInfo are accessed, thus no need for a setter in Process"
	
	^ csInfo ifNil: [csInfo := CSProcessContextInformation new]! !

!MCMczReader methodsFor: '*contexts2-core-override' stamp: 'tfel 4/11/2012 11:52'!
loadDefinitions
	"OVERRIDE: snapshots don't really seem to work with partial methods, ignore them"
	definitions := OrderedCollection new.
	"(self zip memberNamed: 'snapshot.bin') ifNotNil:
		[:m | [^ definitions := (DataStream on: m contentStream) next definitions]
			on: Error do: [:fallThrough ]]."
	"otherwise"
	(self zip membersMatching: 'snapshot/*')
		do: [:m | self extractDefinitionsFrom: m].
! !

!Behavior methodsFor: '*contexts2-core' stamp: 'tfel 2/28/2012 15:05:58.093'!
allCompiledMethods

    ^ Array streamContents: [:stream |
        self withAllSuperclassesDo: [:aClass |
            aClass methodsDo: [:method | 
                stream nextPut: method]]]! !

!Behavior methodsFor: '*contexts2-core' stamp: 'tfel 3/5/2012 14:20:28.909'!
allInvolvedLayers
	
	^ (self layeredMethods gather: [ :each | each allInvolvedLayers ]) asSet! !

!Behavior methodsFor: '*contexts2-core-override-adding/removing methods' stamp: 'tfel 3/28/2012 12:08:56.657'!
basicAddSelector: selector withMethod: compiledMethod 
	"Add the message selector with the corresponding compiled method to the receiver's method dictionary. Do this without sending system change notifications"
	
	| oldMethodOrNil method |
	oldMethodOrNil := self lookupSelector: selector.
	"Empty symbols are used by Object >> withArgs:executeMethod: to temporarily store a method in the methodDict; avoid creating the LayeredMethod."
	compiledMethod methodClass: self; selector: selector.
	(selector isEmpty or: [((CSMethodObject respondsTo: #isBootstrapping) not or: [CSMethodObject isBootstrapping])])
		ifTrue: [ method := compiledMethod ]
		ifFalse: [
			method := self
				contextSConversionOld: (self compiledMethodAt: selector ifAbsent: [ nil ])
				new: compiledMethod.
			method methodClass: self; selector: selector ].
	self methodDict at: selector put: method.
	
	"Now flush Squeak's method cache, either by selector or by method"
	oldMethodOrNil == nil ifFalse: [oldMethodOrNil flushCache].
	selector flushCache.
	((CSMethodObject respondsTo: #isBootstrapping) not or: [
		CSMethodObject isBootstrapping]) ifFalse: [CSLayeredMethod flushAllCaches].! !

!Behavior methodsFor: '*contexts2-core' stamp: 'tfel 3/28/2012 12:08:05.196'!
contextSConversionOld: old new: new
	"old can be nil or a CompiledMethod or a CSLayeredMethod. new can be a CompiledMethod or a CSPartialMethod."
	| layeredMethod |
	((CSMethodObject respondsTo: #isBootstrapping) not or: [
		CSMethodObject isBootstrapping]) ifTrue: [^ new].
	layeredMethod := self layeredMethodFrom: old.
	layeredMethod addPartialMethod: new asPartialMethod.
	^ layeredMethod isLayered
		ifTrue: [ layeredMethod ]
		ifFalse: [ new ] "use the CompiledMethod, if LayeredMethod would be useless."! !

!Behavior methodsFor: '*contexts2-core' stamp: 'ag 12/11/2011 16:43'!
cs2FileOut
	
	self cs2FileOutOn: (FileStream forceNewFileNamed: self name asString, '.st').! !

!Behavior methodsFor: '*contexts2-core' stamp: 'ag 12/11/2011 09:59'!
cs2FileOutCompiledMethod: compiledMethod called: aSelector of: aClass on: aStream
	
	self
		cs2FileOutMultiPart: 
			{ 
			aClass name, ' methodsFor: ''', (aClass organization categoryOfElement: aSelector), ''''.
			compiledMethod getSource
			}
		on: aStream.! !

!Behavior methodsFor: '*contexts2-core' stamp: 'ag 12/20/2011 20:33'!
cs2FileOutMethod: meth called: aSelector of: aClass on: stream
	
	(meth isKindOf: CSLayeredMethod)
		ifTrue: [ meth partialMethods do: [ :partialMethod | self cs2FileOutCompiledMethod: partialMethod method called: aSelector of: aClass on: stream ] ]
		ifFalse: [ self cs2FileOutCompiledMethod: meth called: aSelector of: aClass on: stream ]! !

!Behavior methodsFor: '*contexts2-core' stamp: 'ag 12/11/2011 09:57'!
cs2FileOutMultiPart: aCollectionOfStrings on: stream
	
	stream nextPut: $!!; cr.
	aCollectionOfStrings
		do: [ :str | self cs2FileOutPart: str on: stream ].
	stream nextPut: $!!; cr.! !

!Behavior methodsFor: '*contexts2-core' stamp: 'ag 12/11/2011 10:07'!
cs2FileOutOn: stream
	
	self cs2FileOutPart: self definition on: stream.
	self methodDict keysAndValuesDo: [ :selector :meth |
		self cs2FileOutMethod: meth called: selector of: self on: stream ].! !

!Behavior methodsFor: '*contexts2-core' stamp: 'ag 12/11/2011 09:56'!
cs2FileOutPart: aString on: stream
	
	| tokens |
	tokens := aString asString findTokens: '!!' keep: '!!'.
	tokens do: [ :str |
		stream nextPutAll: 
			(str = '!!'
				ifTrue: [ '!!!!' ]
				ifFalse: [ str ]) ].
	stream nextPut: $!!; cr; cr.! !

!Behavior methodsFor: '*contexts2-core' stamp: 'tfel 3/6/2012 11:38:04.629'!
layeredMethodDict
	"Have to use fromPairs because sometimes a method symbol may appear twice, and newFrom: with a collection of associations errors in that case, whereas newFromPairs: doesn't"
	^ Dictionary newFromPairs: (((methodDict associations
		gather: [:assoc |
			assoc value isContextSMethod
				ifTrue: [
					(assoc value partialMethods collect: [:m | m asSymbol -> m]),
					{assoc key -> assoc value basePartialMethod}]
				ifFalse: [{assoc}]])
		reject: [:assoc | assoc value isNil])
		gather: [:assoc | {assoc key. assoc value}])! !

!Behavior methodsFor: '*contexts2-core' stamp: 'tfel 2/29/2012 11:35:01.304'!
layeredMethodFrom: oldMethod
	"oldMethod can be nil, a CompiledMethod, a CSLayeredMethod or a CSPartialMethod"
	oldMethod ifNil: [^ CSLayeredMethod new].
	^ oldMethod class == CSLayeredMethod
		ifFalse: [CSLayeredMethod new
					addPartialMethod: oldMethod asPartialMethod;
					yourself]
		ifTrue: [oldMethod]! !

!Behavior methodsFor: '*contexts2-core' stamp: 'tfel 3/5/2012 14:19:25.84'!
layeredMethods
	
	^ methodDict values select: [:each | each class == CSLayeredMethod]! !

Object subclass: #CSLayer
	instanceVariableNames: 'layerName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2-Core'!

!CSLayer class methodsFor: 'private' stamp: 'ag 12/23/2011 14:22'!
checkIsSubclass
	
	self == CSLayer ifTrue: [ self error: 'Cannot access singleton-instance of CSLayer itself.' ].! !

!CSLayer class methodsFor: 'private' stamp: 'ag 12/23/2011 14:33'!
getGlobalInstanceOf: aClass withName: aSymbol
	
	^ (Smalltalk includesKey: aSymbol)
		ifTrue: [ | layer |
			layer := Smalltalk at: aSymbol.
			(layer isKindOf: CSLayer)
				ifTrue: [
					layer class == aClass
						ifTrue: [ layer ]
						ifFalse: [ "Delete obsolete CSLayer instances. Kind of a side case, but keeps the system clean."
							Smalltalk removeKey: aSymbol.
							self getGlobalInstanceOf: aClass withName: aSymbol ] ]
				ifFalse: [ self error: 'Global ', aSymbol, ' already exists, cannot create layer with that name.' ] ]
		ifFalse: [
			Smalltalk at: aSymbol put: (aClass basicNew initialize: aSymbol; yourself) ] "Avoid #new"! !

!CSLayer class methodsFor: 'subclassed layers' stamp: 'tfel 2/29/2012 11:28:14.406'!
globalLayerName
	"The name of the layer to be accessed as a global variable. Is accessible as soon as instance has been invoked."
	"Should be subclassResponsibility, but this potentially breaks loading of layers from monticello"
	"self subclassResponsibility."! !

!CSLayer class methodsFor: 'subclassed layers' stamp: 'ag 12/23/2011 14:29'!
instance
	"Singleton-pattern with registration in the global namespace.
	Only for subclasses of CSLayer, CSLayer itself has multiple 'anonymous' instances (which are also registered globally)"
	
	self checkIsSubclass.
	^ self
		getGlobalInstanceOf: self
		withName: self globalLayerName! !

!CSLayer class methodsFor: 'layers' stamp: 'ag 12/23/2011 14:29'!
layerNamed: aSymbol
	"Return the CSLayer-instance associated with aSymbol.
	If a subclass with the according globalLayerName exists, it's singleton-instance is returned.
	Else, an anonymous instance of CSLayer is returned. These objects are created lazily, tracked in a dictionary and freed when become obsolet.e."
	
	^ (self subclassedLayerNamed: aSymbol)
		ifNotNilDo: #instance
		ifNil: [
			self
				getGlobalInstanceOf: CSLayer
				withName: aSymbol ]! !

!CSLayer class methodsFor: 'private' stamp: 'ag 12/22/2011 15:54'!
new
	
	^ self error: 'Dont create instances of CSLayer (or subclasses) manually.'! !

!CSLayer class methodsFor: 'private' stamp: 'ag 12/23/2011 14:23'!
pvtCreateNamed: aSymbol
	"Only internal, for controlled instance creation."
	
	^ self basicNew initialize: aSymbol; yourself! !

!CSLayer class methodsFor: 'private' stamp: 'ag 12/23/2011 14:32'!
removeGlobalInstanceNamed: aSymbol
	
	^ ((Smalltalk at: aSymbol ifAbsent: [ ^ nil ]) isKindOf: CSLayer)
		ifTrue: [ Smalltalk removeKey: aSymbol ]
		ifFalse: [ self error: 'Global ', aSymbol, ' is not an instance of CSLayer' ]! !

!CSLayer class methodsFor: 'subclassed layers' stamp: 'ag 12/23/2011 14:26'!
resetInstance
	"Reset the layer-instance of this class. Only applicable for subclasses."
	
	self checkIsSubclass.
	^ self removeGlobalInstanceNamed: self globalLayerName! !

!CSLayer class methodsFor: 'layers' stamp: 'ag 12/23/2011 14:26'!
resetLayer: aSymbol
	"Resets the global layer-instance named by aSymbol. Takes layers with their own subclass and anonymous layers into account."
	
	^ (self subclassedLayerNamed: aSymbol)
		ifNotNilDo: #resetInstance
		ifNil: [ self removeGlobalInstanceNamed: aSymbol ]! !

!CSLayer class methodsFor: 'private' stamp: 'ag 12/23/2011 14:11'!
subclassedLayerNamed: aSymbol
	
	^ self allSubclasses
		detect: [ :cl | cl globalLayerName = aSymbol ]
		ifNone: [ nil ]! !

!CSLayer methodsFor: 'queries' stamp: 'ag 12/23/2011 15:14'!
allContainingLayeredMethods
	
	^ CSLayeredMethod allInstances
		select: [ :method |
			method partialMethods
				anySatisfy: [ :partial | partial layers includes: self layerName ] ]! !

!CSLayer methodsFor: 'queries' stamp: 'ag 12/23/2011 15:16'!
allContainingMethods
	"Returns a collection of associations from class to selector."
	
	^ self allContainingLayeredMethods
		collect: [ :layeredMethod | layeredMethod methodClass -> layeredMethod selector ]! !

!CSLayer methodsFor: 'queries' stamp: 'ag 12/23/2011 15:52'!
allContainingPartialMethods
	
	| result |
	result := OrderedCollection new.
	self allContainingLayeredMethods
		do: [ :layeredMethod |
			result addAll:
				(layeredMethod partialMethods
					select: [ :partialMethod | partialMethod layers includes: self layerName ]) ].
	^ result! !

!CSLayer methodsFor: 'queries' stamp: 'ag 1/22/2012 14:52:09.315'!
asLayer
	"Also implemented on Symbol, to transparently access this first-class layer object."
	
	^ self! !

!CSLayer methodsFor: 'initialization' stamp: 'ag 12/22/2011 17:18'!
initialize
	
	self error: 'Please use the #initialize: message with the layer-name as parameter.'.! !

!CSLayer methodsFor: 'initialization' stamp: 'ag 12/22/2011 17:18'!
initialize: aSymbol
	
	super initialize.
	layerName := aSymbol.! !

!CSLayer methodsFor: 'accessing' stamp: 'ag 12/22/2011 17:16'!
layerName
	
	^ layerName! !

!CSLayer methodsFor: 'layer handling' stamp: 'ag 12/23/2011 15:33'!
reset
	"Reset the layer-instance. Next time the layer will be accessed, it will result in another object."
	
	^ self class resetLayer: self layerName! !

!CSLayer methodsFor: 'layer handling' stamp: 'ag 1/27/2012 16:49:15.994'!
withLayerDo: aBlock
	"Pass the call on to the name-symbol. TODO in future, the functionality should be replaced here, in the Layer-class."
	
	^ self layerName withLayerDo: aBlock! !

Object subclass: #CSMethodObject
	instanceVariableNames: 'methodClass selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2-Core'!

CSMethodObject class
	instanceVariableNames: 'isBootstrapping'!

CSMethodObject class
	instanceVariableNames: 'isBootstrapping'!

CSMethodObject subclass: #CSLayeredMethod
	instanceVariableNames: 'baseMethod partialMethods layerDict proceedSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2-Core'!

!CSLayeredMethod class methodsFor: 'consistency' stamp: 'tfel 2/29/2012 10:16:13.666'!
checkConsistencyOfInstances
	"self checkConsistencyOfInstances"
	
	super checkConsistencyOfInstances.
	[ CSLayeredMethod allInstances
		allSatisfy: [ :method |
			method partialMethods class == OrderedCollection ]
	] assert.

	[ CSLayeredMethod allInstances
		allSatisfy: [ :method |
			(method isLayered) or: [
			(method methodClass methodDict includes: method) not] ]
	] assert.! !

!CSLayeredMethod class methodsFor: 'consistency' stamp: 'tfel 3/27/2012 09:29:23.419'!
fixConsistencyOfInstances
	"self fixConsistencyOfInstances"
	
	super fixConsistencyOfInstances.
	[ CSLayeredMethod allInstances
		do: [ :method || org | "Classify all partial methods so they show up in the CSBrowser"
			org := method methodClass organization.
			method partialMethods do: [:partial |
				(org categoryOfElement: partial asSymbol) ifNil: [org classify: partial asSymbol under: 'partial methods']]].
	] on: Error do: [ :e | Transcript cr; show: 'Fixing partialMethods-categories of all subinstances of CSLayeredMethod failed: ', e ].
	
	[ CSLayeredMethod allInstances
		do: [ :method | "Replace the collection-instance in the CSLayeredMethod-instance by a Set."
			method setPartialMethods: (OrderedCollection withAll: method partialMethods) ].
	] on: Error do: [ :e | Transcript cr; show: 'Fixing partialMethods-collection of all subinstances of CSLayeredMethod failed: ', e ].
	
	[ CSLayeredMethod allInstances
		do: [ :method | "Replace CSLayeredMethods, that do not actually include layered behaviour, by simple CompiledMethods."
			method isLayered ifFalse: [ method becomeCompiledMethod ] ].
	] on: Error do: [ :e | Transcript cr; show: 'Turning all non-layered subinstances of CSLayeredMethod into CompiledMethods failed: ', e ].

	[ CSLayeredMethod allInstances
		do: [ :method | "Cache all partial methods to their layers"
			method flushCache ].
	] on: Error do: [ :e | Transcript cr; show: 'Caching partial methods failed: ', e ].

	[ CSLayeredMethod allInstances
		do: [ :method | "Cache the proceed selector"
			method initializeProceedSelector ].
	] on: Error do: [ :e | Transcript cr; show: 'Caching proceed selector failed: ', e ].! !

!CSLayeredMethod class methodsFor: 'consistency' stamp: 'tfel 3/27/2012 11:39:09.726'!
flushAllCaches

	self allInstances do: [:method | method flushCache].! !

!CSLayeredMethod class methodsFor: 'constants' stamp: 'ag 12/20/2011 21:39'!
pragmaKeyword
	
	^ #layer:! !

!CSLayeredMethod class methodsFor: 'constants' stamp: 'ag 12/23/2011 16:08'!
proceedSelectorBase
	
	^ #proceed! !

!CSLayeredMethod methodsFor: 'accessing' stamp: 'ag 12/17/2011 21:50'!
activeLayers
	
	^ Processor activeProcess csInfo activeLayers! !

!CSLayeredMethod methodsFor: 'accessing' stamp: 'tfel 3/26/2012 17:29:22.005'!
actualBaseMethod
	"returns the compiled method to execute as a base method, with superclass lookup
	 hand optimized for minimal overhead"
	| cm |
	^ baseMethod == nil
		ifFalse: [baseMethod method]
		ifTrue: [(cm := methodClass superclass lookupSelector: selector) == nil
					ifTrue: [nil]
					ifFalse: [cm class == CompiledMethod
								ifTrue: [cm]
								 ifFalse: [cm actualBaseMethod]]]! !

!CSLayeredMethod methodsFor: 'accessing' stamp: 'tfel 3/26/2012 16:43:58.23'!
addPartialMethod: aPartialMethod

	aPartialMethod ifNil: [ ^ self ].
	aPartialMethod isBase
		ifTrue: [ baseMethod := aPartialMethod ]
		ifFalse: [
			(self hasConflictsWithPartialMethod: aPartialMethod) ifFalse: [
				self partialMethods
					remove: aPartialMethod ifAbsent: [ "nothing" ];
					add: aPartialMethod ]].
	self flushCache.! !

!CSLayeredMethod methodsFor: 'accessing' stamp: 'tfel 3/5/2012 14:21:14.128'!
allInvolvedLayers

	^ self partialMethods gather: [:each | each layers]! !

!CSLayeredMethod methodsFor: 'queries' stamp: 'ag 1/30/2012 16:30:13.142'!
allPartialMethods
	"Return the partial methods in this layered method, inclusive the base-method.
	Returned collection may not be modified, as the internal partial-method-collection may be returned without copying."
	
	^ self includesBaseMethod
		ifTrue: [ self partialMethods copyWith: baseMethod ]
		ifFalse: [ self partialMethods ]! !

!CSLayeredMethod methodsFor: 'accessing' stamp: 'ag 1/30/2012 16:33:16.835'!
baseMethod
	"This does NOT return just the instance field, but unpacks the CompiledMethod from the CSPartialMethod."
	
	^ baseMethod ifNotNilDo: #method! !

!CSLayeredMethod methodsFor: 'accessing' stamp: 'ag 1/30/2012 16:28:31.056'!
basePartialMethod
	
	^ baseMethod! !

!CSLayeredMethod methodsFor: 'queries' stamp: 'ag 1/30/2012 13:39:48.601'!
becomeCompiledMethod
	"This restores the consistency of this object, if it is not layered anymore. First check, if the receiver is still inside its class' methodDict.
	Then, if we have any partial method left, put it's CompiledMethod in the methodDict; else, just delete the slot.
	If this is called while #isLayered returns true, some of the partial methods will just get lost."
	
	(self methodClass methodDict at: self selector ifAbsent: [ nil ]) == self ifFalse: [ ^ self ].
	self includesAnyPartialMethod ifFalse: [ self methodClass methodDict removeKey: self selector ifAbsent: [ "nothing" ] ].
	self compiledMethodReplacement ifNotNilDo: [ :compiledMethod |
		self methodClass methodDict
			at: self selector
			put: compiledMethod ].! !

!CSLayeredMethod methodsFor: 'accessing' stamp: 'ag 1/30/2012 13:39:21.924'!
compiledMethodReplacement
	
	^ self includesAnyPartialMethod ifTrue: [
		self includesBaseMethod
			ifTrue: [ self baseMethod ]
			ifFalse: [ self partialMethods anyOne method ] ]! !

!CSLayeredMethod methodsFor: 'caching' stamp: 'tfel 3/26/2012 16:47:08.165'!
flushCache

	layerDict := IdentityDictionary new.
	self allInvolvedLayers do: [:layer | layerDict at: layer put: (self partialMethodFor: layer)].! !

!CSLayeredMethod methodsFor: 'accessing' stamp: 'ag 1/20/2012 22:44:40.615'!
hasBaseMethod
	
	^ self baseMethod notNil! !

!CSLayeredMethod methodsFor: 'accessing' stamp: 'tfel 3/28/2012 12:19'!
hasConflictsWithPartialMethod: aPartialMethod
	| method |
	method := self partialMethods
			detect: [:m | m layers ~= aPartialMethod layers and: [
						m layers includesAnyOf: aPartialMethod layers]]
			ifNone: [^ false].
	^ (self confirm: 'This will override another method that defines the layers ',
					(method layers intersection: aPartialMethod layers) printString)
		ifTrue: [self partialMethods remove: method. false]
		ifFalse: [true]! !

!CSLayeredMethod methodsFor: 'accessing' stamp: 'ag 1/23/2012 08:35:04.233'!
includesAnyPartialMethod
	"Return true, if any behaviour is still left in this layered method."
	
	^ self includesBaseMethod | self partialMethods notEmpty! !

!CSLayeredMethod methodsFor: 'accessing' stamp: 'ag 1/30/2012 16:31:49.261'!
includesBaseMethod
	
	^ self baseMethod notNil! !

!CSLayeredMethod methodsFor: 'executing' stamp: 'tfel 3/27/2012 09:24:43.02'!
initializeProceedSelector
	| selector |
	selector := self class proceedSelectorBase.
	self selector isUnary ifTrue: [ ^ selector asSymbol ].
	selector := selector, #':'.
	self selector isInfix ifTrue: [ ^ selector asSymbol ].
	(self selector occurrencesOf: $:) - 1
		timesRepeat: [ selector := selector, #with: ].
	proceedSelector := selector asSymbol! !

!CSLayeredMethod methodsFor: 'accessing' stamp: 'ag 1/22/2012 17:24:33.091'!
isLayered
	"Returns true, if this layered method currently does anything different than a simple CompiledMethod.
	If false, this layered method should be replaced by an equivalent CompiledMethod.
	This is the case, if there are no partial methods."
	
	^ self partialMethods notEmpty! !

!CSLayeredMethod methodsFor: 'accessing' stamp: 'ag 1/30/2012 16:30:48.529'!
method
	"Use base method, if possible, else use any partial method. Return nil, if not a single partial method is present."
	
	^ self includesBaseMethod
		ifTrue: [ self baseMethod ]
		ifFalse: [ self partialMethods ifNotEmpty: [ self partialMethods anyOne ] ifEmpty: [ nil ] ]! !

!CSLayeredMethod methodsFor: 'executing' stamp: 'tfel 3/27/2012 11:35:39.402'!
methodChainFor: activeLayers
	"Chain together all partial methods that are currently active.
	Chain is ordered in the way the layers have been activated.
	Caches by key of activeLayers"
	| methodChain m |
	^ layerDict at: activeLayers ifAbsentPut: [
		methodChain := OrderedCollection new: activeLayers size + 1.
		activeLayers do: [:layer |
			(m := layerDict at: layer ifAbsent: []) == nil ifFalse: [methodChain add: m]].
		(m := self actualBaseMethod) == nil ifFalse: [methodChain add: m].
		methodChain]! !

!CSLayeredMethod methodsFor: 'queries' stamp: 'tfel 3/26/2012 16:46:29.686'!
partialMethodFor: aLayerName

	^ self partialMethods
		detect: [:method | method layers includes: aLayerName]
		ifNone: []! !

!CSLayeredMethod methodsFor: 'accessing' stamp: 'ag 1/27/2012 17:07:35.681'!
partialMethods
	
	^ partialMethods ifNil: [ partialMethods := OrderedCollection new ]! !

!CSLayeredMethod methodsFor: 'printing' stamp: 'ag 12/23/2011 15:25'!
printOn: aStream
	
	super printOn: aStream.
	aStream
		nextPutAll: ', ';
		nextPutAll: (self partialMethods size + (self includesBaseMethod ifTrue: [ 1 ] ifFalse: [ 0 ])) asString;
		nextPutAll: ' version(s))'.! !

!CSLayeredMethod methodsFor: 'queries' stamp: 'tfel 3/26/2012 16:44:22.358'!
removePartialMethod: aPartialMethod
	
	aPartialMethod method == self baseMethod
		ifTrue: [ baseMethod := nil ]
		ifFalse: [ self partialMethods remove: aPartialMethod ifAbsent: [] ].
	self methodClass organization removeElement: aPartialMethod asSymbol.
	self isLayered ifFalse: [ self becomeCompiledMethod ].
	self flushCache.! !

!CSLayeredMethod methodsFor: 'accessing' stamp: 'tfel 3/26/2012 16:44:06.3'!
setPartialMethods: aCollection
	"Only for internal use."
	
	partialMethods := aCollection.
	self flushCache.! !

!CSLayeredMethod methodsFor: 'executing' stamp: 'tfel 3/27/2012 10:27:01.302'!
valueWithReceiver: aReceiver arguments: anArray
	"Memorize old method-chain, compute a new one, kick off the execution and restore the old state afterwards."
	
	| oldProcessState methodChain |
	methodChain := self methodChainFor: self activeLayers.
	methodChain size == 0 ifTrue: ["Not a single method to execute..."
		^ aReceiver doesNotUnderstand: (Message selector: self selector arguments: anArray) ].
	oldProcessState := Processor activeProcess csInfo saveState.
	Processor activeProcess csInfo methodChain: methodChain.
	^ [ methodChain first valueWithReceiver: aReceiver arguments: anArray ]
		ensure: [
			Processor activeProcess csInfo restoreStateFrom: oldProcessState ]! !

!CSMethodObject class methodsFor: 'consistency' stamp: 'ag 1/27/2012 17:52:04.164'!
checkAllInstances
	
	Smalltalk garbageCollect. "As the check/fix methods use allInstances/allSubInstances, we should try to collect all obsolete instances."
	^ CSMethodObject allSubclassesDo: #checkConsistencyOfInstances! !

!CSMethodObject class methodsFor: 'consistency' stamp: 'tfel 3/28/2012 12:15'!
checkConsistencyOfInstances
	"self checkConsistencyOfInstances"
	
	[ self allInstances
		noneSatisfy: [ :method |
			(method methodClass methodDict includes: method) and: [
			method selector isNil or: [ method selector isEmpty
			or: [ method methodClass isNil ] ] ] ]
	] assert.! !

!CSMethodObject class methodsFor: 'bootstrapping support' stamp: 'tfel 3/28/2012 12:01:02.205'!
doesNotUnderstand: aMessage
	"During bootstrap, the message for checking bootstrap might not be compiled, yet"
	aMessage selector = #isBootstrapping ifTrue: [^ true].
	^ super doesNotUnderstand: aMessage! !

!CSMethodObject class methodsFor: 'bootstrapping support' stamp: 'tfel 3/28/2012 12:00:17.083'!
doneBootstrapping

	isBootstrapping := false.! !

!CSMethodObject class methodsFor: 'consistency' stamp: 'ag 1/27/2012 17:51:48.267'!
fixAllInstances
	
	Smalltalk garbageCollect. "As the check/fix methods use allInstances/allSubInstances, we should try to collect all obsolete instances."
	^ CSMethodObject allSubclassesDo: #fixConsistencyOfInstances! !

!CSMethodObject class methodsFor: 'consistency' stamp: 'ag 1/30/2012 12:55:08.897'!
fixConsistencyOfInstances
	"self fixConsistencyOfInstances"
	"Sets the selector of all method-object instances to the selector of their underlying CompiledMethod."
	
	[ self allInstances do: [ :methodObject |
		methodObject selector: methodObject method selector ]
	] on: Error do: [ :e | Transcript cr; show: 'Fixing selectors on all instances of ', self, ' failed: ', e ].
	
	[ self allInstances do: [ :methodObject |
		methodObject selector ifEmpty: [ methodObject methodClass methodDict removeKey: #'' ifAbsent: [] ] ]
	] on: Error do: [ :e | Transcript cr; show: 'Deleting instances of ', self, ' with empty selector failed: ', e ]! !

!CSMethodObject class methodsFor: 'bootstrapping support' stamp: 'tfel 3/28/2012 12:00:06.691'!
isBootstrapping

	^ isBootstrapping ~= false! !

!CSMethodObject class methodsFor: 'instance creation' stamp: 'ag 12/20/2011 20:12'!
selector: aSymbol class: aClass
	
	^ self new
		selector: aSymbol;
		methodClass: aClass;
		yourself! !

!CSMethodObject methodsFor: 'accessing' stamp: 'ag 1/19/2012 19:01:38.067'!
at: aNumber
	
	^ self method at: aNumber! !

!CSMethodObject methodsFor: 'executing' stamp: 'ag 12/20/2011 21:19'!
doesNotUnderstand: aMessage
	"Required for all meta messages that need information from the original method."
	
	^ self method
		ifNil: [ self ] "Cannot pass the message on, simulate behavior of an empty method."
		ifNotNilDo: [ :msg | msg perform: aMessage selector withArguments: aMessage arguments ]! !

!CSMethodObject methodsFor: 'literals' stamp: 'tfel 2/29/2012 10:05:23.663'!
hasLiteral: literal

	self method ifNil: [^ false].
	^ self method hasLiteral: literal! !

!CSMethodObject methodsFor: 'literals' stamp: 'tfel 2/29/2012 10:05:35.373'!
hasLiteralThorough: literal

	self method ifNil: [^ false].
	^ self method hasLiteralThorough: literal! !

!CSMethodObject methodsFor: 'testing' stamp: 'tfel 2/23/2012 17:03:30.372'!
isContextSMethod

	^ true! !

!CSMethodObject methodsFor: 'executing' stamp: 'ag 12/20/2011 19:58'!
method
	"Subclasses have to provide real CompiledMethod-objects as substitute for arbitrary messages. If nil is returned, these messages are dropped."
	
	^ self subclassResponsibility! !

!CSMethodObject methodsFor: 'accessing' stamp: 'ag 12/20/2011 20:11'!
methodClass
	"Answer the value of methodClass"

	^ methodClass! !

!CSMethodObject methodsFor: 'accessing' stamp: 'ag 12/20/2011 20:11'!
methodClass: anObject
	"Set the value of methodClass"

	methodClass := anObject! !

!CSMethodObject methodsFor: 'printing' stamp: 'ag 12/23/2011 15:26'!
printOn: aStream
	
	aStream
		nextPutAll: self class name;
		nextPutAll: '(';
		nextPutAll: (self methodClass name ifNil: [ '' ]);
		nextPutAll: '>>';
		nextPutAll: (self selector ifNil: [ #'' ]).! !

!CSMethodObject methodsFor: 'executing' stamp: 'ag 12/16/2011 11:45'!
run: aSelector with: anArrayOfObjects in: aReceiver
	
	^ self valueWithReceiver: aReceiver arguments: anArrayOfObjects! !

!CSMethodObject methodsFor: 'accessing' stamp: 'ag 1/30/2012 16:36:22.041'!
selector
	"Answer the value of selector"

	^ selector! !

!CSMethodObject methodsFor: 'accessing' stamp: 'ag 1/31/2012 15:23:23.931'!
selector: anObject
	"Set the value of selector"
	
	selector := anObject! !

!CSMethodObject methodsFor: 'accessing' stamp: 'ag 1/19/2012 19:01:43.145'!
size
	
	^ self method size! !

!CSMethodObject methodsFor: 'executing' stamp: 'ag 12/20/2011 19:59'!
valueWithReceiver: aReceiver arguments: anArrayOfObjects
	"This message is sent, when the method-object has to execute itself."
	
	^ self subclassResponsibility! !

CSMethodObject subclass: #CSPartialMethod
	instanceVariableNames: 'method layers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2-Core'!

!CSPartialMethod class methodsFor: 'consistency' stamp: 'ag 1/30/2012 13:08:04.048'!
checkConsistencyOfInstances
	
	super checkConsistencyOfInstances.
	
	[ CSPartialMethod allInstances noneSatisfy: [ :method |
		(method methodClass methodDict at: method selector ifAbsent: [])
			== method ]
	] assert.
	
	"TODO another helpfull check would be to check, that no partial methods return true on the #isBase message..."
	"TODO Yet another check would be to check, that instances of partialMEthod, that return true from #isBase really include the layer: pragma in their CompiledMethod"! !

!CSPartialMethod class methodsFor: 'consistency' stamp: 'ag 1/27/2012 17:48:46.172'!
fixConsistencyOfInstances
	
	super fixConsistencyOfInstances.
	
	[ CSPartialMethod allSubInstances do: [ :methodObject |
		(methodObject methodClass methodDict at: methodObject selector ifAbsent: []) == methodObject
			ifTrue: [
				methodObject methodClass methodDict removeKey: methodObject selector ifAbsent: [] ] ]
	] on: Error do: [ :e | Transcript cr; show: 'Deleting all instances of CSPartialMethod from method-dictionaries failed: ', e ].
	
	[ CSLayeredMethod allSubInstances do: [ :methodObject |
		methodObject setPartialMethods: (methodObject partialMethods reject: [ :e | e selector isEmpty ])]
	] on: Error do: [ :e | Transcript cr; show: 'Deleting all instances of CSPartialMethod with empty selectors from their respective layered method failed: ', e ].! !

!CSPartialMethod class methodsFor: 'instance creation' stamp: 'ag 12/23/2011 16:49'!
on: aLayer forMethod: aMethod
	
	^ (self
		selector: aMethod selector
		class: aMethod methodClass)
		method: aMethod;
		layers: aLayer;
		yourself! !

!CSPartialMethod methodsFor: 'comparing' stamp: 'ag 1/30/2012 13:01:04.742'!
= anotherPartialMethod
	
	^ anotherPartialMethod class == self class
		and: [ (layers = anotherPartialMethod internalLayers) & (self selector = anotherPartialMethod selector) & (self methodClass = anotherPartialMethod methodClass) ]! !

!CSPartialMethod methodsFor: 'converting' stamp: 'tfel 2/29/2012 11:40:43.189'!
asPartialMethod

	^ self! !

!CSPartialMethod methodsFor: 'converting' stamp: 'tfel 3/6/2012 11:03:21.136'!
asSymbol

	^ self isBase
		ifTrue: [self selector asSymbol]
		ifFalse: [self printString asSymbol]! !

!CSPartialMethod methodsFor: 'comparing' stamp: 'ag 1/22/2012 17:16:13.838'!
hash
	
	^ layers hash + self selector hash + self class hash! !

!CSPartialMethod methodsFor: 'accessing' stamp: 'ag 1/22/2012 23:11:26.719'!
internalLayers
	"Returns the instance-variable without further checks. For internal use only."
	
	^ layers! !

!CSPartialMethod methodsFor: 'accessing' stamp: 'ag 1/22/2012 17:17:06.694'!
isBase
	
	^ layers isNil! !

!CSPartialMethod methodsFor: 'accessing' stamp: 'ag 1/22/2012 17:04:45.476'!
layers
	"Answer the value of layer. If it is nil, return an empty array, but DONT set the instance-variable itself!!
	The instance variable layer being nil is a marker for this partial-method to be the base-method (see #isBase)."
	
	^ layers ifNil: [ #() ]! !

!CSPartialMethod methodsFor: 'accessing' stamp: 'ag 2/2/2012 10:34:56.272'!
layers: anObject
	"Set the value of layer"

	anObject ifNotNil: [ anObject do: [ :symbol | CSLayer layerNamed: symbol ] ].
	layers := anObject! !

!CSPartialMethod methodsFor: 'accessing' stamp: 'mp 6/13/2010 14:19'!
method
	"Answer the value of method"

	^ method! !

!CSPartialMethod methodsFor: 'accessing' stamp: 'mp 6/13/2010 14:19'!
method: anObject
	"Set the value of method"

	method := anObject! !

!CSPartialMethod methodsFor: 'printing' stamp: 'ag 12/23/2011 15:28'!
printLayersOn: stream
	
	self layers
		do: [ :each | stream nextPutAll: each ]
		separatedBy: [ stream nextPut: Character space ].! !

!CSPartialMethod methodsFor: 'printing' stamp: 'ag 1/22/2012 16:57:41.933'!
printOn: aStream
	
	aStream
		nextPutAll: selector;
		nextPutAll: ' ('.
	self isBase
		ifTrue: [ aStream nextPutAll: '<base>' ]
		ifFalse: [ self printLayersOn: aStream ].
	aStream nextPut: $).! !

!CSPartialMethod methodsFor: 'executing' stamp: 'tfel 3/27/2012 11:20:02.603'!
valueWithReceiver: aReceiver arguments: anArray
	"Memorize in the process-state, that the current method has been started; execute the backing CompiledMethod in the receivers context."
	
	Processor activeProcess csInfo incrementProceedIndex.
	^ [ aReceiver withArgs: anArray executeMethod: self method ]
		ensure: [ Processor activeProcess csInfo decrementProceedIndex ]! !

CSMethodObject subclass: #CSProceedMethod
	instanceVariableNames: 'runningLayeredMethods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2-Core'!

!CSProceedMethod class methodsFor: 'consistency' stamp: 'ag 1/30/2012 12:53:16.454'!
checkConsistencyOfInstances
	"self checkSystemConsistency"
	
	"super checkConsistencyOfInstances." "Super-version not applicable."
	[ CSProceedMethod allInstances
		noneSatisfy: [ :method |
			method methodClass methodDict includesKey: method selector ]
	] assert.! !

!CSProceedMethod class methodsFor: 'consistency' stamp: 'ag 1/23/2012 08:42:51.977'!
fixConsistencyOfInstances
	"self fixConsistencyOfInstances"
	"Remove all leftover instances of ProceedMethod in method-dictionaries of classes.
	ProceedMethod-instances are removed inside ensure:-blocks, but nevertheless sometimes some of them can stay somewhere in method-dictionaries..."
	
	| number |
	"super fixConsistencyOfInstances." "Super-version not applicable."
	number := 0.
	[ CSProceedMethod allInstancesDo: [ :proceed |
			(proceed methodClass methodDict includesKey: proceed selector)
				ifTrue: [
					number := number + 1.
					proceed methodClass methodDict removeKey: proceed selector ] ].
	] on: Error do: [ :e | Transcript cr; show: 'Removing all unused subinstances of CSProceedMethod failed: ', e ].
	^ number! !

!CSProceedMethod class methodsFor: 'as yet unclassified' stamp: 'tfel 3/27/2012 11:26:25.046'!
generateProceeds
	"generates proceed methods on the Object class"
	0 to: 10 do: [:idx || selector args |
		selector := 'proceed' asSymbol.
		idx >= 1 ifTrue: [selector := selector asMutator, ' arg1'].
		idx >= 2 ifTrue: [
			2 to: idx do: [:argIdx | selector := selector, ' with: arg', argIdx]].
		args := idx = 0
					ifTrue: ['#()']
					ifFalse: [((1 to: idx) inject: '{' into: [:acc :nxt | acc, 'arg', nxt, '.']), '}'].
		Object
			compile: selector, '
	| info index |
	info := Processor activeProcess csInfo.
	index := info proceedIndex.
	info methodChain size < index ifTrue: [ ^ self ]. "Method chain has been executed to the end.
														Simulate an empty method"
	^ self withArgs: ', args, ' executeMethod: (info methodChain at: index)'
			classified: '*contexts2-core'
	].! !

!CSProceedMethod methodsFor: 'executing' stamp: 'ag 12/20/2011 20:58'!
method
	"There is no real CompiledMethod to pass incoming messages to."
	
	^ nil! !

!CSProceedMethod methodsFor: 'printing' stamp: 'ag 12/23/2011 15:31'!
printOn: aStream
	
	super printOn: aStream.
	aStream
		nextPutAll: ', count ';
		nextPutAll: (runningLayeredMethods ifNil: [ 0 ]) asString;
		nextPut: $).! !

Object subclass: #CSProcessContextInformation
	instanceVariableNames: 'activeLayers methodChain proceedIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2-Core'!

!CSProcessContextInformation methodsFor: 'accessing' stamp: 'ag 12/20/2011 20:00'!
activeLayers
	^ activeLayers ifNil: [ activeLayers := #() ]! !

!CSProcessContextInformation methodsFor: 'accessing' stamp: 'nw 12/12/2011 17:05'!
activeLayers: layers
	activeLayers := layers! !

!CSProcessContextInformation methodsFor: 'accessing' stamp: 'tfel 3/27/2012 11:20:35.435'!
decrementProceedIndex

	proceedIndex := proceedIndex - 1.! !

!CSProcessContextInformation methodsFor: 'accessing' stamp: 'tfel 3/27/2012 11:30:59.714'!
incrementProceedIndex
	proceedIndex == nil ifTrue: [proceedIndex := 1].
	proceedIndex := proceedIndex + 1.! !

!CSProcessContextInformation methodsFor: 'accessing' stamp: 'ag 12/18/2011 11:13'!
methodChain
	
	^ methodChain! !

!CSProcessContextInformation methodsFor: 'accessing' stamp: 'tfel 3/27/2012 11:24:58.24'!
methodChain: anOrderedCollection
	"resets index"
	methodChain := anOrderedCollection.
	proceedIndex := 1.! !

!CSProcessContextInformation methodsFor: 'accessing' stamp: 'tfel 3/27/2012 11:20:53.767'!
proceedIndex

	^ proceedIndex! !

!CSProcessContextInformation methodsFor: 'layer handling' stamp: 'tfel 3/27/2012 11:21:03.837'!
restoreStateFrom: anArray
	"anArray must be the return value of an earlier #saveState call."
	
	methodChain := anArray first.
	proceedIndex := anArray second.! !

!CSProcessContextInformation methodsFor: 'layer handling' stamp: 'tfel 3/27/2012 11:21:06.965'!
saveState
	
	^ { methodChain. proceedIndex }! !

!CSProcessContextInformation methodsFor: 'layer handling' stamp: 'ag 12/20/2011 23:54'!
withLayers: aCollection do: aBlock
	"Convenience method for layer-manipulation. Stores old layers and restores them after executing aBlock."
	
	| oldLayers |
	oldLayers := self activeLayers.
	self activeLayers: aCollection.
	^ aBlock ensure: [ self activeLayers: oldLayers ]! !

!Object methodsFor: '*contexts2-core' stamp: 'ag 12/23/2011 11:30'!
currentLayer
	"Return the first of the currentLayers for convenience.
	This should be the first activated layer that has lead to the activation of the last partial method."
	
	^ self currentLayers ifNotNilDo: #first! !

!Object methodsFor: '*contexts2-core' stamp: 'tfel 3/27/2012 11:53:40.826'!
currentLayers
	"Return the layers of the current execution. If no method associated to any layer is on the execution stack, nil is returned.
	Else, the last partial method that has started execution determines the 'current layers'.
	These are the layers that have lead to the activation of this partial method (-> the subset of the currently active layers, that intersects with the partial methods layers).
	This returns (sub)instances of CSLayer.
	If a subclass of CSLayer with the right globalLayerName exists, its singleton-instance is used, else an anonymous instance of CSLayer."
	
	| info partialMethod |
	info := Processor activeProcess csInfo.
	(info proceedIndex ~= nil and: [info proceedIndex > 1])
		ifTrue: [partialMethod := info methodChain at: info proceedIndex - 1]
		ifFalse: ["slow path"
			(thisContext findContextSuchThat: [:ctxt |
				ctxt receiver class ==  CSPartialMethod])
					ifNotNilDo: [:ctxt | partialMethod := ctxt receiver]].
	partialMethod ifNil: [^ nil].
	^ ((info activeLayers intersection: partialMethod layers)
		collect: [ :layername | CSLayer layerNamed: layername ])
			ifEmpty: [ nil ]! !

!Object methodsFor: '*contexts2-core' stamp: 'tfel 2/23/2012 17:05:44.781'!
isContextSMethod

	^ false! !

!Object methodsFor: '*contexts2-core' stamp: 'tfel 3/27/2012 11:26:27.978'!
proceed
	| info index |
	info := Processor activeProcess csInfo.
	index := info proceedIndex.
	info methodChain size < index ifTrue: [ ^ self ]. "Method chain has been executed to the end.
														Simulate an empty method"
	^ self withArgs: #() executeMethod: (info methodChain at: index)! !

!Object methodsFor: '*contexts2-core' stamp: 'tfel 3/27/2012 11:26:27.986'!
proceed: arg1
	| info index |
	info := Processor activeProcess csInfo.
	index := info proceedIndex.
	info methodChain size < index ifTrue: [ ^ self ]. "Method chain has been executed to the end.
														Simulate an empty method"
	^ self withArgs: {arg1.} executeMethod: (info methodChain at: index)! !

!Object methodsFor: '*contexts2-core' stamp: 'tfel 3/27/2012 11:26:27.992'!
proceed: arg1 with: arg2
	| info index |
	info := Processor activeProcess csInfo.
	index := info proceedIndex.
	info methodChain size < index ifTrue: [ ^ self ]. "Method chain has been executed to the end.
														Simulate an empty method"
	^ self withArgs: {arg1.arg2.} executeMethod: (info methodChain at: index)! !

!Object methodsFor: '*contexts2-core' stamp: 'tfel 3/27/2012 11:26:27.994'!
proceed: arg1 with: arg2 with: arg3
	| info index |
	info := Processor activeProcess csInfo.
	index := info proceedIndex.
	info methodChain size < index ifTrue: [ ^ self ]. "Method chain has been executed to the end.
														Simulate an empty method"
	^ self withArgs: {arg1.arg2.arg3.} executeMethod: (info methodChain at: index)! !

!Object methodsFor: '*contexts2-core' stamp: 'tfel 3/27/2012 11:26:27.996'!
proceed: arg1 with: arg2 with: arg3 with: arg4
	| info index |
	info := Processor activeProcess csInfo.
	index := info proceedIndex.
	info methodChain size < index ifTrue: [ ^ self ]. "Method chain has been executed to the end.
														Simulate an empty method"
	^ self withArgs: {arg1.arg2.arg3.arg4.} executeMethod: (info methodChain at: index)! !

!Object methodsFor: '*contexts2-core' stamp: 'tfel 3/27/2012 11:26:28'!
proceed: arg1 with: arg2 with: arg3 with: arg4 with: arg5
	| info index |
	info := Processor activeProcess csInfo.
	index := info proceedIndex.
	info methodChain size < index ifTrue: [ ^ self ]. "Method chain has been executed to the end.
														Simulate an empty method"
	^ self withArgs: {arg1.arg2.arg3.arg4.arg5.} executeMethod: (info methodChain at: index)! !

!Object methodsFor: '*contexts2-core' stamp: 'tfel 3/27/2012 11:26:28.002'!
proceed: arg1 with: arg2 with: arg3 with: arg4 with: arg5 with: arg6
	| info index |
	info := Processor activeProcess csInfo.
	index := info proceedIndex.
	info methodChain size < index ifTrue: [ ^ self ]. "Method chain has been executed to the end.
														Simulate an empty method"
	^ self withArgs: {arg1.arg2.arg3.arg4.arg5.arg6.} executeMethod: (info methodChain at: index)! !

!Object methodsFor: '*contexts2-core' stamp: 'tfel 3/27/2012 11:26:28.004'!
proceed: arg1 with: arg2 with: arg3 with: arg4 with: arg5 with: arg6 with: arg7
	| info index |
	info := Processor activeProcess csInfo.
	index := info proceedIndex.
	info methodChain size < index ifTrue: [ ^ self ]. "Method chain has been executed to the end.
														Simulate an empty method"
	^ self withArgs: {arg1.arg2.arg3.arg4.arg5.arg6.arg7.} executeMethod: (info methodChain at: index)! !

!Object methodsFor: '*contexts2-core' stamp: 'tfel 3/27/2012 11:26:28.006'!
proceed: arg1 with: arg2 with: arg3 with: arg4 with: arg5 with: arg6 with: arg7 with: arg8
	| info index |
	info := Processor activeProcess csInfo.
	index := info proceedIndex.
	info methodChain size < index ifTrue: [ ^ self ]. "Method chain has been executed to the end.
														Simulate an empty method"
	^ self withArgs: {arg1.arg2.arg3.arg4.arg5.arg6.arg7.arg8.} executeMethod: (info methodChain at: index)! !

!Object methodsFor: '*contexts2-core' stamp: 'tfel 3/27/2012 11:26:28.008'!
proceed: arg1 with: arg2 with: arg3 with: arg4 with: arg5 with: arg6 with: arg7 with: arg8 with: arg9
	| info index |
	info := Processor activeProcess csInfo.
	index := info proceedIndex.
	info methodChain size < index ifTrue: [ ^ self ]. "Method chain has been executed to the end.
														Simulate an empty method"
	^ self withArgs: {arg1.arg2.arg3.arg4.arg5.arg6.arg7.arg8.arg9.} executeMethod: (info methodChain at: index)! !

!Object methodsFor: '*contexts2-core' stamp: 'tfel 3/27/2012 11:26:28.012'!
proceed: arg1 with: arg2 with: arg3 with: arg4 with: arg5 with: arg6 with: arg7 with: arg8 with: arg9 with: arg10
	| info index |
	info := Processor activeProcess csInfo.
	index := info proceedIndex.
	info methodChain size < index ifTrue: [ ^ self ]. "Method chain has been executed to the end.
														Simulate an empty method"
	^ self withArgs: {arg1.arg2.arg3.arg4.arg5.arg6.arg7.arg8.arg9.arg10.} executeMethod: (info methodChain at: index)! !

!Object methodsFor: '*contexts2-core-override-message handling' stamp: 'tfel 3/28/2012 12:27'!
withArgs: argArray executeMethod: compiledMethod
	"Execute compiledMethod against the receiver and args in argArray"
	| selector |
	<primitive: 188>
	selector := #''.
	self class addSelectorSilently: selector withMethod: compiledMethod.
	^ [self perform: selector withArguments: argArray]	ensure: [self class basicRemoveSelector: selector]! !

!MCMethodDefinition methodsFor: '*contexts2-core' stamp: 'tfel 2/23/2012 19:09:07.297'!
selector: aSymbol

	selector := aSymbol! !

!CompiledMethodWithNode class methodsFor: '*contexts2-core-override-instance creation' stamp: 'ag 12/20/2011 21:39'!
generateMethodFromNode: aMethodNode trailer: bytes
	
	| method |
	method := aMethodNode generate: bytes.
	(method pragmas anySatisfy: [:each | each keyword = CSLayeredMethod pragmaKeyword ])
		ifTrue: [method := method asPartialMethod].
	^ self method: method node: aMethodNode.! !

!CompiledMethodWithNode methodsFor: '*contexts2-core-override-accessing' stamp: 'tfel 4/11/2012 12:00'!
selector

	^ self method isContextSMethod
		ifTrue: [self method asSymbol]
		ifFalse: [self node selector]! !
CSBrowser initialize!
